// ------------------------------------------------------------------------------
// Bullets - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Bullets.java
// There are two kinds of bullets that repulse one another.
// ------------------------------------------------------------------------------

class Ball
{
  float vmax;    // Maximum speed
  float amax;    // Maximum acceleration
  float rmax;    // Maximum repulsion force
  float x;
  float y;
  float vX;
  float vY;
  String type;
  
  Ball(float X, float Y, float VX, float VY, String Type)
  {
    vmax = 5;
    amax = 1.5;
    rmax = 1.5;
    x = X;
    y = Y;
    vX = VX;
    vY = VY;
    type = Type;
  }
  
  void display()
  {
    if ( type == "A" )
    {
      noStroke();
      fill(0,0,0);
      triangle(x,y+4,x,y-4,x+10,y);
    }
    else
    {  
      stroke(200,200,200);
      strokeWeight(4);
      point(x,y);
    }
  }
  
  void truncate()
  {
    if ( sqrt(pow(vX,2)+pow(vY,2)) > vmax )
    {
      float theta = atan(vY/vX);
      vX = abs(vX)/vX*vmax*cos(theta);
      vY = abs(vY)/vY*sqrt(pow(vmax,2)-pow(vX,2));
    }
  }
  
  void repulse()
  {
    for ( int i=0; i<num; i++ )
    {
      if ( abs(x-balls[i].x) < 15 && abs(y-balls[i].y) < 15 && abs(x-balls[i].x) > 0 && abs(y-balls[i].y) > 0 && balls[i].type != type && type == "B")
      {
        float theta = atan((balls[i].y-y)/(balls[i].x-x));
        float aX = -abs(balls[i].x-x)/(balls[i].x-x)*rmax*cos(theta);
        float aY = -abs(balls[i].y-y)/(balls[i].y-y)*sqrt(pow(rmax,2)-pow(aX,2));
    
        vX = aX + vX;
        vY = aY + vY;
      }
    }
  }
  
  void move()
  {
    x = vX + x;
    y = vY + y;
    
    if ( type == "A" && x > width )
    {
      x = 0;
      y = random(0,height);
    }
  }
}
